﻿Option Strict On

Imports Microsoft.WindowsAPICodePack.Controls
Imports Microsoft.WindowsAPICodePack.Shell

Public Class fExplorerControl

    Private Sub fExplorerControl_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        'disables the naviagation buttons
        btnNext.Enabled = False
        btnPrevious.Enabled = False
        explorerBrowser.ContentOptions.SingleClickActivate = True
        'when the form is loaded, navigate to the desktop by default
        explorerBrowser.Navigate(CType(KnownFolders.Desktop, ShellObject))
    End Sub

    Private Sub btnPrevious_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnPrevious.Click
        'when the Previous button is hit, we can navigate using the history
        explorerBrowser.NavigateLogLocation(NavigationLogDirection.Backward)
    End Sub

    Private Sub btnNext_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnNext.Click
        'when the Next button is hit, we can navigate using the history
        explorerBrowser.NavigateLogLocation(NavigationLogDirection.Forward)
    End Sub

    Private Sub explorerBrowser_NavigationComplete(ByVal sender As Object, ByVal e As Microsoft.WindowsAPICodePack.Controls.NavigationCompleteEventArgs) Handles explorerBrowser.NavigationComplete
        'each time the control navigates, we check if we can enabled the previous and/or the next buttons
        btnPrevious.Enabled = explorerBrowser.NavigationLog.CanNavigateBackward
        btnNext.Enabled = explorerBrowser.NavigationLog.CanNavigateForward
    End Sub

    Private Sub btnSelect_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSelect.Click
        'Displays the first selected item
        MessageBox.Show("you selected: " + explorerBrowser.SelectedItems(0).ParsingName)
    End Sub
End Class