﻿Option Strict On

Imports Microsoft.WindowsAPICodePack.Dialogs

Public Class fTaskDialog

    Private Sub FileDialog_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles FileDialog.Click
        Dim dlg As New CommonOpenFileDialog
        dlg.Multiselect = True
        If Not dlg.ShowDialog = CommonFileDialogResult.Cancel Then
            Dim strSummary As String = String.Empty
            For Each fn As String In dlg.FileNames
                strSummary += "     " + fn + " " + Environment.NewLine
            Next
            MessageBox.Show("You have selected : " + Environment.NewLine + strSummary)
        End If
        dlg.Dispose()
    End Sub

    Dim td As TaskDialog = Nothing
    Private Sub TaskDialog_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles TaskDialog.Click
        td = New TaskDialog

        td.Icon = TaskDialogStandardIcon.Information
        td.Cancelable = True
        td.Caption = "This is a sample Task Dialog"
        td.InstructionText = "Follow these instructions to complete the task"
        td.Text = "This is the place where more detailed explanation goes. There is room" + _
                     " for plenty of text so you can cover a lot of ground for users who can't decide" + _
                     " which option to select."

        'Command Link 1
        Dim clStartOver As New TaskDialogCommandLink( _
            "clStartOver", _
            "Start Over", _
            "Start again from the beginning")
        AddHandler clStartOver.Click, AddressOf clStartOver_Click
        td.Controls.Add(clStartOver)

        'Command Link 2
        Dim clTryAgain As New TaskDialogCommandLink("clTryAgain", _
            "Try Again", "Try again with a new one")
        AddHandler clTryAgain.Click, AddressOf clTryAgain_Click
        td.Controls.Add(clTryAgain)

        'Command Link 3
        Dim clQuit As New TaskDialogCommandLink("clQuit", _
            "Quit", "Quit this program")
        AddHandler clQuit.Click, AddressOf clQuit_Click
        td.Controls.Add(clQuit)

        td.FooterCheckBoxText = "You can provide an option like Always Use Saved File here."
        td.HyperlinksEnabled = True
        td.FooterText = "This footer text can explain even more of what is going on " + _
                        "(<a href=""http://www.emoreau.com"">www.emoreau.com</a>)."
        AddHandler td.HyperlinkClick, AddressOf TaskDialogHyperlinkClick

        td.ExpansionMode = TaskDialogExpandedDetailsLocation.ExpandContent
        td.DetailsCollapsedLabel = "Click here to expand"

        'Small bug here the space will be kept at the bottom of the TaskDialog to show this complete text
        Dim strExpandedControlText As String
        strExpandedControlText = "This is where you would start writing you biography!" + _
                                 Environment.NewLine + _
                                 "This is a true story..."
        'strExpandedControlText = "This is where you would start writing you biography!" + _
        '                         Environment.NewLine + _
        '                         "This is a true story..." + _
        '                        Environment.NewLine + _
        '                        "Line 2 ..." + _
        '                        Environment.NewLine + _
        '                        "Line 3 ..." + _
        '                        Environment.NewLine + _
        '                        "Line 4 ..." + _
        '                        Environment.NewLine + _
        '                        "Line 5 ..." + _
        '                        Environment.NewLine + _
        '                        "Line 6 ..." + _
        '                        Environment.NewLine + _
        '                        "Line 7 ..." + _
        '                        Environment.NewLine + _
        '                        "Line 8 ..." + _
        '                        Environment.NewLine + _
        '                        "Line 9 ..." + _
        '                        Environment.NewLine + _
        '                        "Line 10 ..." + _
        '                        Environment.NewLine + _
        '                        "Line 11 ..." + _
        '                        Environment.NewLine + _
        '                        "Line 12 ..." + _
        '                        Environment.NewLine + _
        '                        "Line 13 ..."

        td.DetailsExpandedLabel = strExpandedControlText

        td.DetailsExpandedText = <s>This text will appear just under the Instruction section and before the first Command Link

            This is a true story...
            Line 1
            Line 2
            Line 3
            Line 4
            Line 5
            Line 6
            Line 7
            Line 8
            Line 9
            Line 10
            Line 11
            Line 12
            Line 13
            Line 14
            Line 15
            Line 16
            Line 17
            Line 18
            Line 19
            Line 20
        </s>.Value

        Dim tdr As TaskDialogResult = td.Show()
        'td.Show()

        If td.FooterCheckBoxChecked Then
            MessageBox.Show("the Checkbox is CHECKED")
        Else
            MessageBox.Show("the Checkbox is NOT CHECKED")
        End If

        td.Dispose()

        'td = Nothing
    End Sub

#Region "Task Dialog Command Links events"

    Private Sub clStartOver_Click(ByVal sender As Object, ByVal e As System.EventArgs)
        MessageBox.Show("You chose to start over")
        If td IsNot Nothing Then
            td.Close(TaskDialogResult.Ok)
        End If
    End Sub

    Private Sub clTryAgain_Click(ByVal sender As Object, ByVal e As System.EventArgs)
        MessageBox.Show("You chose to try again")
        If td IsNot Nothing Then
            td.Close(TaskDialogResult.Retry)
        End If
    End Sub

    Private Sub clQuit_Click(ByVal sender As Object, ByVal e As System.EventArgs)
        MessageBox.Show("You chose to quit")
        If td IsNot Nothing Then
            td.Close(TaskDialogResult.Close)
        End If
    End Sub

    Private Sub TaskDialogHyperlinkClick(ByVal sender As Object, ByVal e As TaskDialogHyperlinkClickedEventArgs)
        Process.Start(e.LinkText)
    End Sub

#End Region 'Task Dialog Command Links events

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        lblVersion.Text = String.Concat(My.Computer.Info.OSFullName, "  ", My.Computer.Info.OSVersion)
    End Sub

End Class
